/**
 * Created by yadongw on 2017/8/25.
 */

FontCache.prototype.cacheList = {};
FontCache.prototype.size = 0;
FontCache.prototype.length = 0;
FontCache.prototype.get = function(key){
    if(this.cacheList[key]){
        this.cacheList[key].time = (new Date()).valueOf();
        return this.cacheList[key].value;
    }else{
        return null;
    }
};
FontCache.prototype.set = function(key, value){
    if(!isNaN(parseInt(key))){
        throw new Error("key should be string, number is not in the first");
    }

    var cacheValue = this.get(key);
    if(cacheValue == null && this.length >= this.maxLength){
        this._removeFirst();
    }
    this.length++;
    this.cacheList[key] = {
        time: (new Date()).valueOf(),
        value: value
    };
};
FontCache.prototype.remove = function(key){
    this.length--;
    return delete this.cacheList[key];
};
FontCache.prototype.debug = function(){
    console.log(this.cacheList);
    console.log(this._getSize());
};

FontCache.prototype._removeFirst = function(){
    var firstTime = 9999999999999;
    var firstIndex;
    for(var i in this.cacheList){
        if(this.cacheList[i].time < firstTime){
            firstTime = this.cacheList[i].time;
            firstIndex = i;
        }
    }
    //console.log("_removeFirst");
    //console.log(this.cacheList[firstIndex].time);
    if(firstIndex){
        this.remove(firstIndex);
    }
};
FontCache.prototype._getSize = function(){
    var size = 0;
    for(var i in this.cacheList){
        size += (this.cacheList[i].value + "").toString().length;
    }
    return size;
};
function FontCache(maxLength){
    this.maxLength = maxLength;
}